//////////////////////////////////////////////////////////////////////
// light.cpp: implementation for the Light class
// -Kyoung Shin Park (2013 Spring)
//////////////////////////////////////////////////////////////////////
#include "light.h"

namespace moglclass
{

Light::Light(glm::vec4& position_, glm::vec4& ambient_, glm::vec4& diffuse_, glm::vec4& specular_, float constantAtt_, float linearAtt_, float quadraticAtt_, float spotCutoff_, float spotExponent_, glm::vec3& spotDirection_)
{
	set(position_, ambient_, diffuse_, specular_, constantAtt_, linearAtt_, quadraticAtt_, spotCutoff_, spotExponent_, spotDirection_);
}

void Light::set(glm::vec4& position_, glm::vec4& ambient_, glm::vec4& diffuse_, glm::vec4& specular_, float constantAtt_, float linearAtt_, float quadraticAtt_, float spotCutoff_, float spotExponent_, glm::vec3& spotDirection_)
{
	Position = position_;
	Ambient = ambient_;
	Diffuse = diffuse_;
	Specular = specular_;
	
	ConstantAttenuation = constantAtt_;
	LinearAttenuation = linearAtt_;
	QuadraticAttenuation = quadraticAtt_;

	SpotCutoff = spotCutoff_;
	SpotExponent = spotExponent_;
	SpotDirection = spotDirection_;
}

// set light uniform variable
void Light::setUniform(Program* p, std::string lightName)
{
	p->setUniform(lightName+".Position", Position);
	p->setUniform(lightName+".Ambient", Ambient);
	p->setUniform(lightName+".Diffuse", Diffuse);
	p->setUniform(lightName+".Specular", Specular);
	p->setUniform(lightName+".ConstantAttenuation", ConstantAttenuation);
	p->setUniform(lightName+".LinearAttenuation", LinearAttenuation);
	p->setUniform(lightName+".QuadraticAttenuation", QuadraticAttenuation);
	p->setUniform(lightName+".SpotCutoff", SpotCutoff);
	p->setUniform(lightName+".SpotExponent", SpotExponent);
	p->setUniform(lightName+".SpotDirection", SpotDirection);
}

} // moglclass namespace