#pragma once
//////////////////////////////////////////////////////////////////////
// light.h: interface for the Light class.
// -Kyoung Shin Park (2014 Spring)
//////////////////////////////////////////////////////////////////////
#include "moglclass.h"
#include "shaders.h"

namespace moglclass
{

class Light
{
public:
	Light(glm::vec4& position=glm::vec4(0.0f, 0.0f, 1.0f, 0.0f), glm::vec4& ambient=glm::vec4(0.4f, 0.4f, 0.4f, 1.0f), glm::vec4& diffuse=glm::vec4(1.0f, 1.0f, 1.0f, 1.0f), glm::vec4& specular=glm::vec4(1.0f, 1.0f, 1.0f, 1.0f), float constantAtt=1, float linearAtt=0, float quadraticAtt=0, float spotCutoff=180, float spotExponent=0, glm::vec3& spotDirection=glm::vec3(0.0f, 0.0f, -1.0f));
	void set(glm::vec4& position=glm::vec4(0.0f, 0.0f, 0.0f, 1.0f), glm::vec4& ambient=glm::vec4(0.4f, 0.4f, 0.4f, 1.0f), glm::vec4& diffuse=glm::vec4(1.0f, 1.0f, 1.0f, 1.0f), glm::vec4& specular=glm::vec4(1.0f, 1.0f, 1.0f, 1.0f), float constantAtt=1, float linearAtt=0, float quadraticAtt=0, float spotCutoff=180, float spotExponent=0, glm::vec3& spotDirection=glm::vec3(0.0f, 0.0f, -1.0f));
	void setUniform(Program* p, std::string lightName);

	glm::vec4 Position; // light position (w=1 positional light, w=0 directional light)
	glm::vec4 Ambient; // ambient light color
	glm::vec4 Diffuse; // diffuse light color
	glm::vec4 Specular; // specular light color
	float SpecularShininess; // specular shininess

	float ConstantAttenuation; // light attenuation
	float LinearAttenuation;
	float QuadraticAttenuation;

	float SpotCutoff;	// if (SpotCutoff < 180) then spotlight
	float SpotExponent;
	glm::vec3 SpotDirection;
};

} // moglclass namespace
